#include <stdio.h>
#include <vector>

bool r[100][11000];
int n;
int w[100];

void precalc() {
    r[0][w[0]] = true;
    r[0][0] = true;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < 10000; j++)
            r[i][j+w[i]] |= r[i-1][j];

        for (int j = 0; j < 10000; j++)
            r[i][j] |= r[i-1][j];
    }
}

void solve(int k) {
    if (!r[n-1][k]) {
        printf("-1\n");
        return;
    }

    std::vector<int> res;
    for (int i = n - 1; i > 0; i--)
        if (k-w[i]>=0 && r[i-1][k-w[i]]) {
            k -= w[i];
            res.push_back(w[i]);
            continue;
        }

    if (k != 0)
        res.push_back(w[0]);

    printf("%d", res.size());
    for (int i = 0; i < res.size(); i++)
        printf(" %d", res[i]);

    printf("\n");
}

int main(int argc, char *argv[])
{
    int m;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d", &w[i]);
    scanf("%d", &m);
    precalc();
    for (int i = 0; i < m; i++) {
        int k;
        scanf("%d", &k);
        solve(k);
    }
    return 0;
}
