#include <stdio.h>
#include <algorithm>

int r[100][400];

int raptor[9][11]={
    {0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0},
    {1, 1, 1, 0 ,0, 0, 0, 0, 0, 0, 0},
    {0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1},
    {0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0},
    {0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0},
    {0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0}
};

bool checkRaptor(int x, int y) {
    for (int i = 0; i < 9; i++)
        for (int j = 0; j < 11; j++)
            if (!r[y+i][x+j] && raptor[i][j])
                return false;

    return true;
}

void mirrorRaptor() {
    for (int i = 0; i < 9; i++)
        for (int j = 0; j < 5; j++)
            std::swap(raptor[i][j], raptor[i][10-j]);
}

int main()
{
	int w, h;
    scanf("%d%d\n", &h, &w);
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j += 4) {
			char c;
			scanf("%c", &c);
			char *buf;
			if (c=='0')
				buf="0000";
			else if (c=='1')
				buf="0001";
			else if (c=='2')
				buf="0010";
			else if (c=='3')
				buf="0011";
			else if (c=='4')
				buf="0100";
			else if (c=='5')
				buf="0101";
			else if (c=='6')
				buf="0110";
			else if (c=='7')
				buf="0111";
			else if (c=='8')
				buf="1000";
			else if (c=='9')
				buf="1001";
			else if (c=='A')
				buf="1010";
			else if (c=='B')
				buf="1011";
			else if (c=='C')
				buf="1100";
			else if (c=='D')
				buf="1101";
			else if (c=='E')
				buf="1110";
			else
				buf="1111";
			
			for (int k = 0; k < 4; k++)
				r[i][j+k]=buf[k]-'0';
		}
		scanf("\n");
	}
	
	int res = 0;
	for (int i = 0; i < h-8; i++)
		for (int j = 0; j < w-10; j++)			
			if (checkRaptor(j, i))
				res++;
			
	mirrorRaptor();
	for (int i = 0; i < h-8; i++)
		for (int j = 0; j < w-10; j++)			
			if (checkRaptor(j, i))
				res++;
	
	printf("%d\n", res);

    return 0;
}

