#include <vector>
#include <stdio.h>

bool dfs(int v, std::vector<bool> &valid, 
         const std::vector<std::vector<int> > &r) {
    if (!valid[v])
        return false;

    if (v == 2)
        return true;

    valid[v] = false;
    for (int i = 0; i < r[v].size(); i++)
        if (dfs(r[v][i], valid, r))
            return true;

    return false;
}

void solve() {
//    freopen(inp.toUtf8().constData(), "r", stdin);
//    freopen(outp.toUtf8().constData(), "w", stdout);

    int n, m;
    std::vector<bool> valid; valid.push_back(false);
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; i++) {
        int a;
        scanf("%d", &a);
        if (a == 100)
            valid.push_back(false);
        else
            valid.push_back(true);
    }

    std::vector<std::vector<int> > r; r.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        scanf("%d%d", &a, &b);
        r[a].push_back(b);
        r[b].push_back(a);
    }

    if (dfs(1, valid, r))
        printf("Yes\n");
    else
        printf("No\n");
}

int main() {
	solve();
	return 0;
}
